%%This code is used on the Radar data from Thales, and can be used to run
%%repeated tests giving averages of all runs.

close all
clear all
format compact
format short g


% No. of tests on one dataset (i.e if changing a parameter) - leave at 1
% for a single run
SIZE=1;

% No. of repeated experiments in this datafile - leave at 1 for a single
% run
repeateach=1;

% load data in file called 'dataset'
load dataset
[n,dim]=size(dataset);

%data storage variables
recerror=zeros(n,SIZE,repeateach);
nlinks=zeros(n,SIZE,repeateach);
nnodes=zeros(n,SIZE,repeateach);
nclasses=zeros(n,SIZE,repeateach);
avrecerror=zeros(SIZE,repeateach);
avnlinks=zeros(SIZE,repeateach);
avnnodes=zeros(SIZE,repeateach);
avnclasses=zeros(SIZE,repeateach);
time=zeros(SIZE,repeateach);

%if changing a parameter give it's range here
PARAM=linspace(0.05,0.11,SIZE);

%close all and save data
    close all   
    save radarres repeat* av* recerror nlinks nnodes nclasses dim time SIZE PARAM
    clear all
    load radarres

for repeat=1:repeateach
%% LOOP TO REPEAT FOR EACH SITUATION
    for R=1:SIZE;
    
        
        
    load dataset
    [n,dim]=size(dataset);
    dataclass=zeros(n,1);

%% initialise psom - PARAMETERS!
    an=0.11        %node building parameter - euclidean distance threshold for creation of new neurons
    acl=an     %cluster threshold - neurons closer than this are pulled together
    ar=1           %maximum link length - links 'longer' than this are removed
    bcplus=1/ar    %close neuron update - scale factor for update of neurons in neighbourhood of focus
%     bcminus=-1/ar;  %far neuron update - scale factor for update of neurons outside neighbourhood of focus
    bcminus=0
%     ba=0.01    %ageing parameter - how much links are aged each iteration
    ba=1.0002
    bv=0.2

%% change a parameter??
    
%     acl=PARAM(R);
%     disp(['acl=' num2str(acl)])

%% continue algorithm


    %initialise
    %'neurons'
    x=zeros(3,dim);
    x(1,:)=rand(1,dim);
    x(2,:)=x(1,:)+0.05*(-1 +2*rand(1,dim));
    x(3,:)=x(1,:)+0.05*(-1 +2*rand(1,dim));

    % x=zero(3,3);


    %classes
    class=ones(3,1);
    currentclass=1;
    
    %classmean contains the mean position of each class so far
    classmean=zeros(1,dim);
    %classsq contains the sum of the elements squared
    classsq=zeros(1,dim);
    %classstd contains the maximum standard deviation (from the elements) of each class so far
    classstd=zeros(1,dim);
    %classno contains the no. of elements assigned to each class number
    classno=zeros(1,1);
    
    %classexit: 0=still present, -1=faded through time, n=combined with
    %class n
    classexit=zeros(1,1);
    
      
    %'links'
    L=sparse(3,3);
    L(1,2)=norm(x(1,:)-x(2,:));
    L(3,2)=norm(x(1,:)-x(2,:));
    L(2,1)=L(1,2);
    L(2,3)=L(3,2);

    %speed of animation
    framerate=input('Framerate? ');
    if isempty(framerate)
        framerate=n+1;
    end
    v=0;
%% loop through data
    tic
    [n,dim]=size(dataset);
    
    subplot(2,2,1);
    grid on
    hold on
    plot3(dataset(:,1),dataset(:,2),dataset(:,3),'oy')
    
    %%%%%%%%%%%%%
    % MAIN LOOP %
    %%%%%%%%%%%%%
    
    for q=1:n %cycle through data vectors
        totalclasses=size(classmean,1);
         % establish size of neuron list (network)
         M=size(x,1);

 
%% drawing bit

        if mod(q,5000)==0
            disp(['Data point: ' num2str(q)]);
            disp(['Current no. of classes: ' num2str(nclasses(q-1,R))]);
            disp(['Total classes used: ' num2str(totalclasses)]);
%             imagesc(full(L),[0 1]);
%             drawnow
        end
        if dim==3
            if mod(q,framerate)==0
                v=v+1;


                %dataset view
                subplot(2,2,1)
                view([v,20]);

                %Link Matrix View
                subplot(2,2,4)

                imagesc(full(L));
                colorbar;
                axis tight;
                axis square;
                caxis([0 ar]);

                %Classmean view
                subplot(2,2,2)

                plot3(classmean(:,1),classmean(:,2),classmean(:,3),'xk','Markersize',5,'MarkerFaceColor','k')
                text(classmean(:,1),classmean(:,2),classmean(:,3), num2str((1:totalclasses)'),'HorizontalAlignment', 'right');
                axis([0 1 0 1 0 1]);
                view([v,20]);
                grid on

                %Network view
                subplot(2,2,3)
                grid on
    %           %plot current input in red cross
                plot3(dataset(q,1),dataset(q,2),dataset(q,3),'xr','MarkerSize',20); 
                hold on
                
                %plot neurons
                plot3(x(:,1),x(:,2),x(:,3),'kx', 'MarkerSize',10);

                axis([0 1 0 1 0 1]);
                view([v,20]);

                %draw links
                for i=1:M %plot links and label neurons
                    text(x(i,1),x(i,2),x(i,3),['  ' num2str(class(i))]);
                    for j=1:i
                       if L(i,j)~=0 %if a link is present
                            plot3([x(i,1) x(j,1)],[x(i,2) x(j,2)],[x(i,3) x(j,3)],'k','LineWidth',3,'Color',L(i,j)/ar*[1 1 1]);
                       end
                    end        
                end
                hold off
                title(['q= ' num2str(q)]);
                grid on
                drawnow;
    %             F=getframe(gcf);
    %             mymov=addframe(mymov,F);
            end
        end
%% back to main loop
                   
            
            %if all nodes are eliminated - reset
           if M==0
                %initialise 'neurons'
                x=zeros(3,dim);
                x(1,:)=rand(1,dim);
                x(2,:)=x(1,:)+0.05*(-1 +2*rand(1,dim));
                x(3,:)=x(1,:)+0.05*(-1 +2*rand(1,dim));

                %classes
                currentclass=currentclass+1;
                class=currentclass*ones(3,1);
                classmean=[classmean; zeros(1,dim)];
                classstd=[classstd; zeros(1,dim)];
                classno=[classno; 0];
                classsq=[classsq; zeros(1,dim)];
                classexit=[classexit; 0];

                %'links'
                L=sparse(3,3);
                L(1,2)=norm(x(1,:)-x(2,:));
                L(3,2)=norm(x(1,:)-x(2,:));
                L(2,1)=L(1,2);
                L(2,3)=L(3,2);
            end
            
            M=size(x,1);
            
            %SET u=CURRENT INPUT VECTOR
            u=dataset(q,:);
            
            %FIND AND UPDATE FOCUS
            %calculate norms of differences
            dn=sqrt(sum((repmat(u,M,1)-x).^2,2));


            %find the smallest difference and hence the focus (and its index)
            [d,f]=min(dn);

            recerror(q,R,repeat)=d;

            %label focus z
            z=x(f,:);


            if d<=an     
                %%IF FOCUS IS CLOSE ENOUGH TO INPUT THEN UPDATE IT AND ITS NEIGHBOURS

                %Update focus (uses paramater bv)
                z=z+bv*(u-z);
                x(f,:)=z;

                %assign this input data the class of the focus
                foclass=class(f);
                dataclass(q)=foclass;
                
                %update class data variables
                if classno(foclass)==0
                    classmean(foclass,:)=u;
                    classsq(foclass,:)=u.^2;
                    classno(foclass)=1;
                else
                    classmean(foclass,:)=(classmean(foclass,:)*classno(foclass)+u)/(classno(foclass)+1);
                    classno(foclass)=classno(foclass)+1;
                    classsq(foclass,:)=classsq(foclass,:)+u.^2;
                    classstd(foclass,:)=sqrt(classsq(foclass,:)/classno(foclass)-classmean(foclass,:).^2);
                end
                
                                
                %NEIGHBOURHOOD UPDATE
                %find which neurons are in neighbourhood
                neighs=find(L(:,f)~=0); 

                sn=length(neighs);
                zs=repmat(z,sn,1);
                
                
                % calculate vector of distances to neighbours
                disttoneighs=sqrt(sum((zs-x(neighs,:)).^2,2)); 
                
                %either
%                 dist=disttoneighs;
                
                %or use
                dist=L(neighs,f);
                
                %boolean valued matrices representing near and far neighbours
                near=dist<an; %used to be acl here
                far=dist>=an;

                %update near neighbours

                    
                    L(neighs,f)= near.*disttoneighs + ba*far.*L(neighs,f); %new method - restate near links and perform another age on far ones

%                     L(neighs,f)= dist; %old method - update lengths of all neighbours

                %make symmetric
                L(f,neighs)=L(neighs,f);

                %move close neurons closer (proportional to link length)
                x(neighs,:)=x(neighs,:)+(diag(L(neighs,f)))*diag(near)*(zs - x(neighs,:));

                %list classes combining with focus class
                classescombining=setxor(nonzeros(unique(near.*class(neighs))),foclass);
                                               
                %update these classes
                class(neighs)=class(neighs) + near.*(class(f)*ones(sn,1)-class(neighs));
                
                %if the last neuron from a certain class has gone, then
                %make a note where it combined with. Possible problem in
                %standard deviation calculation here...
                if ~isempty(classescombining)
                    classestomerge=[];
                    for p=1:length(classescombining)
                       if isempty(intersect(class,classescombining(p)))
                          classexit(classescombining(p))=foclass;
                          classestomerge=[classestomerge; classescombining(p)];
                       end
                    end
                    if ~isempty(classestomerge)
                        newno=sum(classno(classestomerge))+classno(foclass);
                        classmean(foclass,:)=(sum(classno(classestomerge)'*classmean(classestomerge,:))+classno(foclass)*classmean(foclass,:))/newno;
                        classno(foclass)=newno;
                        classsq(foclass,:)=sum(classsq(classestomerge,:))+classsq(foclass,:);
                        classstd(foclass,:)=classsq(foclass,:)/classno(foclass)-classmean(foclass,:).^2;
                    end
                end
                
               

            else % create new group
                
                % store old classes
                oldclasses=find(classexit==-1);
                
                %if no old classes then create a new group
                if isempty(oldclasses)
                    %make new class
                    currentclass=currentclass+1;
                    class=[class; currentclass*ones(3,1)];
                    dataclass(q)=currentclass;
                    classmean=[classmean; u];
                    classno=[classno; 1];
                    classsq=[classsq; u.^2];
                    classstd=[classstd; zeros(1,dim)];
                    
                    classexit=[classexit; 0];
                
                else
                    %check for similar old classes
                    comparison=classmean(oldclasses,:)-repmat(u,length(oldclasses),1);
                    dist=sqrt(sum(comparison.^2,2));
                    [shortd,index]=min(dist);
                    nearcl=oldclasses(index);

                    newxs=zeros(3,dim);
                    
                    %if new input is closer than the 1 SD of the old class
                    %then reuse this label
                    if shortd<max(classstd(nearcl,:));
%                     if shortd<an;   
                       %make new neurons named as older class 
                       class=[class; nearcl*ones(3,1)];
                       dataclass(q)=nearcl;

                       %reinstate class
                       classexit(nearcl)=0;

                       %update class info
                       classmean(nearcl,:)=(classmean(nearcl,:)*classno(nearcl) + u)/(classno(nearcl)+1);
                       classno(nearcl)=classno(nearcl)+1;
                       classsq(nearcl,:)=classsq(nearcl,:)+u.^2;
                       classstd(nearcl,:)=sqrt(classsq(nearcl,:)/classno(nearcl)-classmean(nearcl,:).^2);

                    else
                        %make new class
                        currentclass=currentclass+1;
                        class=[class; currentclass*ones(3,1)];
                        dataclass(q)=currentclass;
                        classmean=[classmean; u];
                        classno=[classno; 1];
                        classsq=[classsq; u.^2];
                        classstd=[classstd; zeros(1,dim)];
                        classexit=[classexit; 0];
                    end

                    
                end
                
               
                
                newxs(1,:)=u;
                newxs(2,:)=u+0.05*(-1 +2*rand(1,dim));
                newxs(3,:)=u+0.05*(-1 +2*rand(1,dim));

                x=[x; newxs]; %add the new neurons

                %make links
    %             L=[L zeros(M,3); zeros(3,M) zeros(3,3)]; %fill up link space

                %connect focus to all of new nodes 
                L(f,M+2)=norm(z-x(M+2,:));
                L(f,M+1)=norm(z-x(M+1,:));
                L(f,M+3)=norm(z-x(M+3,:));
                L(M+2,f)=L(f,M+2);
                L(M+1,f)=L(f,M+1);
                L(M+3,f)=L(f,M+3);

                %connect new nodes to each other
                L(M+1,M+2)=norm(x(M+1,:)-x(M+2,:));
                L(M+2,M+3)=norm(x(M+2,:)-x(M+3,:));
                L(M+3,M+1)=norm(x(M+3,:)-x(M+1,:));

                L(M+2,M+1)=L(M+1,M+2);
                L(M+3,M+2)=L(M+2,M+3);
                L(M+1,M+3)=L(M+3,M+1);
            end

            %NETWORK AGING
            M=size(L,1);
           
     
            %age
            L=L*ba;
            
            %remove old links
            (L<ar).*L;
           
            nlinks(q,R,repeat)=nnz(L);
            
            % delete neurons outside [0 1]x[0 1]
            deltoolarge=0;
            [deltoolarge,cols]=find(x>1.1 | x<-0.1); %find indices of cols with entries too large
            L(deltoolarge,:)=[];
            L(:,deltoolarge)=[];
            x(deltoolarge,:)=[];
            class(deltoolarge)=[];
            
            %delete neurons with no links
            delnolinks=0;
            [delnolinks,cols]=find(sum(L,2)==0);
            
            classesgoing=unique(class(delnolinks));
           
            L(delnolinks,:)=[];
            L(:,delnolinks)=[];
            x(delnolinks,:)=[];
            class(delnolinks)=[];
           
             for p=1:length(classesgoing)
               if isempty(intersect(class,classesgoing(p)))
                  classexit(classesgoing(p))=-1; 
               end
            end
            

            nclasses(q,R,repeat)=size(unique(class),1);
            
          
    end 
%% output when data is finished
    
    disp([num2str(q) ' pieces of data processed'])
    avrecerror(R,repeat)=mean(recerror(1:n,R));
    avnlinks(R,repeat)=mean(nlinks(1:n,R));
    avnnodes(R,repeat)=mean(nnodes(1:n,R));
    avnclasses(R,repeat)=mean(nclasses(1:n,R));
    time(R,repeat)=toc;
    disp('Average Recognition Error')
    disp(avrecerror(R,repeat))
    disp('Average No. Links')
    disp(avnlinks(R,repeat))
    disp('Average No. Nodes')
    disp(avnnodes(R,repeat))
    disp('Average No. Classes')
    disp(avnclasses(R,repeat))
    disp('Final No. Classes')
    disp(size(union(class,class),1));
    disp('Time Taken')
    disp(time(R,repeat))
    
%%
    md=max(dataclass);
    mi=max(inputclass);
    if md==0
        md=1;
    end
    
    countc=zeros(md,mi);
    for i=1:n
        countc(dataclass(i),inputclass(i))=countc(dataclass(i),inputclass(i))+1;
    end

    [ncorrect,newclass]=max(countc);
    
    countccopy=countc;
    
    %check if two patterns assigned to same class
    while (length(union(newclass,newclass))<5 && nnz(ncorrect)>=5)
        disp('classes overlapped!');
        newclasses=union(newclass,newclass);
           
            for i=1:length(newclasses)
               [a,b]=max(ncorrect.*(newclass==newclasses(i)));
               for j=1:5    
                   if (newclass(b)==newclass(j) && j~=b)
                      countccopy(newclass(j),j)=0;
                   end
               end
            end
            [ncorrect,newclass]=max(countccopy);

    end
    
  
%     pcorrect=ncorrect(:,1:5)./[500 200 100 100 100] * 100;

    missed(R,:,repeat)=emitternumbers'-ncorrect;
    
%     missed(R,:,repeat)=[500 200 100 100 100]-ncorrect(:,1:5);

    [rn,rncl]=max(countc,[],2);
    
    gained(:,R,repeat)=sum(countc,2)-rn;
 

    avrecerror(R,repeat)=mean(recerror(1:n,R));
    avnlinks(R,repeat)=mean(nlinks(1:n,R));
    avnnodes(R,repeat)=mean(nnodes(1:n,R));
    time(R,repeat)=toc;

    
    sum(missed)
    sum(gained)

    save radarres 
   
    end
   
end
